#include <cxxtls/utf.h>
#include <string>
#include <fstream>
#include <stdlib.h>
#include <iostream>

using namespace std;


void bomb(char const *msg, size_t value=0)
{
   cout << msg << ':' << value << endl;
   exit(1);
}


int main()
{
    string line;

    size_t lineNo = 0;

    while(std::getline(cin, line))
    {
        size_t size = line.size();

        char const *scan = line.data();
        char const *end  = scan + size;


        ++lineNo;

        if(lineNo == 1)
        {
            cxxtls::utf::encoding type = cxxtls::utf::streamEncoding(scan,end); // will increment scan

            if(    type != cxxtls::utf::utf8_enc 
               &&  type != cxxtls::utf::utf7_enc
              )
            {
                cout << "Error:  invalid encoding:  " << cxxtls::utf::encodingName(type) << endl;
                exit(1);
            }
        }

        string outBuff;

        cxxtls::utf::decoder<cxxtls::utf::utf8_enc> decoder;

        while(scan < end)
        {
           char const *prev = scan;

           size_t tmp = decoder(scan,end);

           if(prev == scan)
           {
              bomb("decoder did not increment the iterator", size_t(scan - line.data()));
           }

           outBuff += char(cxxtls::utf::conflate(tmp));
        }

        cout << outBuff << endl;
    }
}
